#include <stdio.h>
#include <stdlib.h>
#include <klocale.h>
#include "dlgfracparams.h"
#include "fracglobals.h"
//#include "dlgfracparams.moc"

FracParamsDlg::FracParamsDlg(DrawWidget* Clnt, QWidget* parent, const char* name):
     QTabDialog (parent, name, TRUE, WStyle_DialogBorder)
{
int Lauf;
char Strg[128];
QLabel *ParLab[16];

//fprintf(stdout,"FracParamsDlg::FracParamsDlg\n");

   setCaption(i18n("Fractal-Parameters"));
   //setFocusPolicy(QWidget::StrongFocus);
   Client = Clnt;
   Fractal = Client->Fractal;

   QWidget* General = new QWidget(this, "General");
   // Iterationen
   MaxIterSpin = new QSpinBox(General, "MaxIterSpin");
   MaxIterSpin->setGeometry(130,30,80,22);
   MaxIterSpin->setRange(1,10000000);
   //MaxIterSpin->setEditable(TRUE);
   QPushButton* PPBtn = new QPushButton("++", General, "PPBtn");
   PPBtn->setGeometry(212,30,15,11);
   PPBtn->setAutoRepeat(TRUE);
   connect(PPBtn,SIGNAL(clicked()), this, SLOT(PPBtnClick()));
   QPushButton* MMBtn = new QPushButton("--", General, "MMBtn");
   MMBtn->setGeometry(212,41,15,11);
   MMBtn->setAutoRepeat(TRUE);
   connect(MMBtn,SIGNAL(clicked()), this, SLOT(MMBtnClick()));

   QLabel *MaxIterLab = new QLabel(i18n("Maxiter:"),General);
   MaxIterLab->setGeometry(20,30,95,20);
   // Rechenmethode
   QLabel* CalcLabel = new QLabel(i18n("Calcmode:"), General, "CalcLabel");
   CalcLabel->setGeometry(20,60,95,15);
   CalcCombo = new QComboBox(General, "CalcCombo");
   CalcCombo->setGeometry(130,60,120,20);
   CalcCombo->insertItem(i18n("Line by Line"));
   CalcCombo->insertItem(i18n("Rectangles"));
   CalcCombo->setCurrentItem(Client->CalcMethod);

   // Eckpunkte
   QWidget* Corners = new QWidget(this, "Corners");

   MinXEdit = new QLineEdit(Corners, "MinXEdit");
   MaxXEdit = new QLineEdit(Corners, "MaxXEdit");
   MinYEdit = new QLineEdit(Corners, "MinYEdit");
   MaxYEdit = new QLineEdit(Corners, "MaxYEdit");

   MinXEdit->setGeometry( 70,50,170,22);
   MinYEdit->setGeometry(270,50,170,22);
   MaxXEdit->setGeometry( 70,80,170,22);
   MaxYEdit->setGeometry(270,80,170,22);

   QLabel *MinLab = new QLabel(i18n("Min:"), Corners);
   QLabel *MaxLab = new QLabel(i18n("Max:"), Corners);
   QLabel *ReLab  = new QLabel(i18n("Real:"), Corners);
   QLabel *ImLab  = new QLabel(i18n("Imag:"), Corners);

   MinLab->setGeometry(20,50,45,20);
   MaxLab->setGeometry(20,80,45,20);
   ReLab->setGeometry(70,28,60,20);
   ImLab->setGeometry(270,28,60,20);

   QPushButton* DefBtn = new QPushButton(i18n("Defaults"), Corners, "DefBtn");
   DefBtn->setGeometry(160, 130,80,30);
   connect(DefBtn, SIGNAL(clicked()), this, SLOT(DefaultCorners()) );

   muprintf(Strg, "%0.20f", Fractal->li);   MinXEdit->setText(Strg);
   muprintf(Strg, "%0.20f", Fractal->re);   MaxXEdit->setText(Strg);
   muprintf(Strg, "%0.20f", Fractal->un);   MinYEdit->setText(Strg);
   muprintf(Strg, "%0.20f", Fractal->ob);   MaxYEdit->setText(Strg);


   // Convergency
   QWidget* Konvergenz = new QWidget(this, "Convergency");
   MaxIterSpin->setValue(Fractal->MaxIter);

   // Konvergenzlimit (Bailout)
   BailEdit = new QLineEdit(Konvergenz, "BailEdit");
   BailEdit->setGeometry(130,30,125,22);
   QLabel* BailLab = new QLabel(i18n("Bailout:"), Konvergenz, "BailLab");
   BailLab->setGeometry(20,30,100,20);
   // Konvergenzmethode
   QStrList* ConvList = new QStrList;
   ConvList->append("Default");
   ConvList->append("Real");
   ConvList->append("Imag");
   ConvList->append("And");
   ConvList->append("Or");
   ConvCmb = new QComboBox(Konvergenz, "ConvCmb");
   //ConvCmb = new QComboBox(ConvList, Konvergenz, "ConvCmb");
   ConvCmb->insertStrList(ConvList);
   ConvCmb->setGeometry(130,60,125,22);
   QLabel* ConvLab = new QLabel(i18n("Convfunc:"), Konvergenz, "ConvLab");
   ConvLab->setGeometry(20,60,80,20);

   ConvCmb->setCurrentItem(Fractal->ConvMode);
   muprintf(Strg, "%0.14f", Fractal->BailOut);   BailEdit->setText(Strg);

   // Seite Postcompute
   QWidget* PostCompute = new QWidget(this, "PostCompute");
   QGroupBox* InsideGroup = new QGroupBox(i18n("Inside Parameters"), PostCompute, "InsideGroup");
   InsideGroup->setGeometry(10,10,240,100);
   QLabel* InsideLabel = new QLabel(i18n("Inside"), InsideGroup, "InsideLabel");
   InsideLabel->setGeometry(10,20,60,14);
   InsideCombo = new QComboBox(InsideGroup, "InsideCombo");
   InsideCombo->setGeometry(90,20,120,20);
   InsideCombo->insertItem(i18n("Color X"));
   InsideCombo->insertItem("Maxiter");
   InsideCombo->insertItem("Multiply");
   InsideCombo->insertItem("Altitude");
   InsideCombo->insertItem("Addition");
   InsideCombo->insertItem("atan");
   InsideCombo->setCurrentItem(Fractal->InsideMethod);

   QLabel* InsideColorLabel = new QLabel(i18n("Insidecolor:"), InsideGroup, "InsideColorLabel");
   InsideColorLabel->setGeometry(10,50,75,20);
   InsideColorSpin = new QSpinBox(InsideGroup, "InsideColorSpin");
   InsideColorSpin->setGeometry(90,50,80,22);
   InsideColorSpin->setRange(0,255);
   //InsideColorSpin->setEditable(TRUE);
   InsideColorSpin->setValue(Fractal->InsideColor);

   QGroupBox* OutsideGroup = new QGroupBox(i18n("Outside Parameters"), PostCompute, "OutsideGroup");
   OutsideGroup->setGeometry(10,120,240,155);
   QLabel* OutsideLabel = new QLabel(i18n("Outside"), OutsideGroup, "OutsideLabel");
   OutsideLabel->setGeometry(10,20,60,14);
   OutsideCombo = new QComboBox(OutsideGroup, "OutsideCombo");
   OutsideCombo->setGeometry(90,20,120,20);
   OutsideCombo->insertItem("Iter");
   OutsideCombo->insertItem(i18n("Color X"));
   OutsideCombo->insertItem("Potential");
   OutsideCombo->insertItem("Multiply");
   OutsideCombo->insertItem("atan");
   OutsideCombo->insertItem("Addition");
   OutsideCombo->setCurrentItem(Fractal->OutsideMethod);
   
   // OutsideColor
   QLabel* OutsideColorLabel= new QLabel(i18n("Outsidecolor:"), OutsideGroup, "OutsideColorLabel");
   OutsideColorLabel->setGeometry(10,50,75,14);
   OutsideColorSpin = new QSpinBox(OutsideGroup, "OutsideColorSpin");
   OutsideColorSpin->setGeometry(90,50,80,22);
   OutsideColorSpin->setRange(0,255);
   //OutsideColorSpin->setEditable(TRUE);
   OutsideColorSpin->setValue(Fractal->OutsideColor);

   // Potentialvalue
   QLabel* PotentialLabel = new QLabel(i18n("Potential:"), OutsideGroup, "PotentialLabel");
   PotentialLabel->setGeometry(10,80,60,14);
   PotentialEdit = new QLineEdit(OutsideGroup, "PotentialEdit");
   PotentialEdit->setGeometry(90,80,125,22);
   muprintf(Strg, "%f", Fractal->PotentialSlope);
   PotentialEdit->setText(Strg);

   QGroupBox* ColorGroup = new QGroupBox(i18n("Color Mapping"), PostCompute, "ColorGroup");
   ColorGroup->setGeometry(260,10,240,150);
   QLabel* ColorLab = new QLabel(i18n("Colormode"), ColorGroup, "ColorLab");
   ColorLab->setGeometry(10,15,75,20);
   ColorCombo = new QComboBox(ColorGroup, "ColorCombo");
   ColorCombo->setGeometry(90,20,120,20);
   ColorCombo->insertItem("linear");
   ColorCombo->insertItem("log");
   ColorCombo->setCurrentItem(Client->Fractal->ColorMode);
   QLabel* ColorLab2 = new QLabel(i18n("First Color"), ColorGroup, "ColorLab2");
   ColorLab2->setGeometry(10,50,75,20);
   LogFirstColorSpin = new QSpinBox(ColorGroup, "LogFirstColorSpin");
   LogFirstColorSpin->setGeometry(90,50,60,20);
   LogFirstColorSpin->setRange(0,1000000);
   //LogFirstColorSpin->setEditable(TRUE);
   LogFirstColorSpin->setValue(Client->Fractal->LogFirstColor);
   QLabel* ColorLab3 = new QLabel("Shift", ColorGroup, "ColorLab3");
   ColorLab3->setGeometry(10,80,70,20);
   LogShiftEdit = new QLineEdit(ColorGroup, "LogShiftEdit");
   LogShiftEdit->setGeometry(90,80,100,20);
   muprintf(Strg,"%0.5f", Client->Fractal->LogShift);
   LogShiftEdit->setText(Strg);
   AutoLogCheck = new QCheckBox(i18n("Compute First Color"), ColorGroup, "AutoLogCheck");
   AutoLogCheck->setGeometry(20,110,200,20);
   AutoLogCheck->setChecked(Client->Fractal->AutoLogColor);

   QGroupBox* OrbitParamsGroup = new QGroupBox(i18n("Orbit Parameters"), PostCompute, "OrbitParamsGroup");
   OrbitParamsGroup->setGeometry(260,180,240,120);
   QLabel* ColoringModeLabel = new QLabel(i18n("Colormode"), OrbitParamsGroup);
   ColoringModeLabel->setGeometry(10,20,75,20);
   OrbitColorModeCombo = new QComboBox(OrbitParamsGroup);
   OrbitColorModeCombo->setGeometry(90,20,120,20);
   OrbitColorModeCombo->insertItem(i18n("Colorchange"));
   OrbitColorModeCombo->insertItem(i18n("Additive"));
   OrbitColorModeCombo->setCurrentItem(Client->OrbitDisplayMode);

   // Seite Parameter (allgemein)
   QWidget* Params = new QWidget(this, "Parameter");
   QLabel* WarnLab1 = new QLabel(i18n("These are type-independ parameters"), Params,"WarnLab1");
   WarnLab1->setGeometry(10,10,380,15);
   QLabel* WarnLab2 = new QLabel(i18n("see also 'type-specific', if any..."), Params,"WarnLab2");
   WarnLab2->setGeometry(10,25,380,15);
   // Parameter
   for (Lauf=0; Lauf<16; Lauf++) {
      sprintf(Strg, "p%d", Lauf);
      ParLab[Lauf] = new QLabel(Strg, Params, Strg);
      ParLab[Lauf]->setGeometry(20+(Lauf/8)*195,60+25*(Lauf%8),30,22);
      Par[Lauf]=new QLineEdit(Params, Strg);
      Par[Lauf]->setGeometry(45+(Lauf/8)*200,60+25*(Lauf%8),130,22); 

      muprintf(Strg, "%0.14f", Fractal->p[Lauf]);
      Par[Lauf]->setText(Strg);
   }
   QPushButton* DefParamsBtn = new QPushButton(i18n("Defaults"), Params, "DefParamsBtn");
   DefParamsBtn->setGeometry(290,10,80,30);
   connect(DefParamsBtn, SIGNAL(clicked()), this, SLOT(DefaultParameters()) );

   // Seite Info
   QWidget* Info = new QWidget(this, "Info");
   FracNr   = new QLabel("", Info, "FracNr");
   FracNr->setGeometry(10,10,280,20);
   FracName = new QLabel("", Info, "FracName");
   FracName->setGeometry(10,35,280,20);
   FracInfo = new QLabel("", Info, "FracInfo");
   FracInfo->setGeometry(10,70,450,200);
   FracInfo->setAlignment(AlignLeft+AlignTop);

   sprintf(Strg,i18n("internal number : %d"), Fractal->GetFracType());
   FracNr->setText(Strg);
   sprintf(Strg,i18n("Fractalname : %s"), Fractal->GetFracName());
   FracName->setText(Strg);
   FracInfo->setText(Fractal->GetFracInfo());

   addTab(General, i18n("General"));
   addTab(Corners, i18n("Corners"));
   addTab(Konvergenz, i18n("Convergency"));
   addTab(PostCompute, i18n("Postcompute"));
   addTab(Params, i18n("Parameters"));
   addTab(Info, i18n("Information"));

   // setOKButton();
   setFixedSize(550,400);
   setCancelButton();
}

/*void FracParamsDlg::SetCornerParams(double x1, double y1, double x2, double y2)
// Alle Parameter auf der Seite "General" setzen
{
   char strg[20];

   sprintf(strg, "%0.14f", x1);   MinXEdit->setText(strg);
   sprintf(strg, "%0.14f", x2);   MaxXEdit->setText(strg);
   sprintf(strg, "%0.14f", y1);   MinYEdit->setText(strg);
   sprintf(strg, "%0.14f", y2);   MaxYEdit->setText(strg);
}

int FracParamsDlg::GetCornerParams(double *x1, double *y1, double *x2, double *y2)
// Alle Parameter auf der Seite "General" lesen
{
   char *eptr;
   double X1,X2,Y1,Y2;

   //fprintf(stdout,"s=>%s<\n",MinXEdit->text());
   eptr=NULL;
   X1 = strtod(MinXEdit->text(), &eptr);
//fprintf(stdout,"eptr=>%s<\n",eptr);
   if (*eptr!=0) return FALSE;
//fprintf(stdout,"x1 ok\n");   

   X2 = strtod(MaxXEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;
   
   Y1 = strtod(MinYEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;
   
   Y2 = strtod(MaxYEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;
   
   *x1=X1;  *y1=Y1;  *x2=X2;  *y2=Y2; 
   return TRUE;
}

void FracParamsDlg::SetGeneralParams(int MaxIter)
{
//char strg[32];

   MaxIterSpin->setValue(MaxIter);
}

int FracParamsDlg::GetGeneralParams(int* MaxIter)
{
//fprintf(stdout,"Maxiter=%d\n",*MaxIter);
   *MaxIter=MaxIterSpin->getValue();
   return TRUE;
}

void FracParamsDlg::SetConvParams(int ConvMode, double BailOut)
{
char strg[32];

   ConvCmb->setIndex(ConvMode);
   sprintf(strg, "%0.14f", BailOut);   BailEdit->setText(strg);
}

int FracParamsDlg::GetConvParams(int* ConvMode, double* BailOut)
{
   char* eptr=NULL;
   double Bail;

   Bail = strtod(BailEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;

   *BailOut = Bail;
   *ConvMode=ConvCmb->getIndex();
   return TRUE;
}

void FracParamsDlg::SetParamParams(double *p)
{
char Strg[32];
int Lauf;

   for (Lauf=0; Lauf<16; Lauf++) {
      sprintf(Strg, "%0.14f", *p);
      p++;
      Par[Lauf]->setText(Strg);
   }
}

int FracParamsDlg::GetParamParams(double *p)
{
double f[16];
int Lauf;
char *eptr=NULL;

   for (Lauf=0; Lauf<16; Lauf++) {
      f[Lauf] = strtod(Par[Lauf]->text(), &eptr);
      if (*eptr!=0){
         // fprintf(stdout,"error %d  >%s<\n",Lauf,Par[Lauf]->text());
         return FALSE;
      }
   }
   
   for (Lauf=0; Lauf<16; Lauf++) {
      *p = f[Lauf];
      p++;
   }
   return TRUE;
}

void FracParamsDlg::SetInfoParams(int Nr, char* Name, char* InfoText)
{
char Strg[128];

   sprintf(Strg,"internal number : %d", Nr);
   FracNr->setText(Strg);
   sprintf(Strg,"Fractalname : %s", Name);
   FracName->setText(Strg);
   FracInfo->setText(InfoText);
}
*/
void FracParamsDlg::DefaultCorners()
// Eckpunkte auf die Startup-Werte setzen
{
char strg[32];
double a,b,c,d;
//fprintf(stdout,"DefaultCorners()\n");

   Fractal->SetDefaultCorners(&a,&b,&c,&d);
   sprintf(strg, "%0.14f", a);   MinXEdit->setText(strg);
   sprintf(strg, "%0.14f", b);   MaxXEdit->setText(strg);
   sprintf(strg, "%0.14f", c);   MinYEdit->setText(strg);
   sprintf(strg, "%0.14f", d);   MaxYEdit->setText(strg);
}

void FracParamsDlg::DefaultParameters()
{
char Strg[32];
int Lauf;

   for (Lauf=0; Lauf<16; Lauf++) {
      sprintf(Strg, "%0.14f", Fractal->SetDefaultParams(Lauf));
      Par[Lauf]->setText(Strg);
   }
}

const char* FracParamsDlg::SetParams(void)
// Alle Parameter in das Fraktalobjekt zurckschreiben
{
   char* eptr;
   int Lauf;
   double li,re,un,ob;   // Eckpunkte
   int MaxIter;          // Iterationstiefe;
   int ConvMode;         // Konvergenztestmenthode
   double BailOut;       // Grenzwert
   double p[16];         // Float-Params;
   int InsMode,OutMode;  // Rechenmodi Inside & Outside
   int InsCol, OutCol;   // Farben       "         "
   double PotSlope;      // Potential
   int CalcM;            // Rechenmethode
   int ColMode,LFirstCol;// Farben
   double LogShift;
   int AutoLogColor;     // Erste Farbe automatisch berechnen
   int OrbColMode;       // Farbgebung bei Orbit-Typen

   // Seite Corners
   eptr=NULL;
   li = strtod(MinXEdit->text(), &eptr);
   if (*eptr!=0) return "XMin";

   re = strtod(MaxXEdit->text(), &eptr);
   if (*eptr!=0) return "XMax";
   
   un = strtod(MinYEdit->text(), &eptr);
   if (*eptr!=0) return "YMin";
   
   ob = strtod(MaxYEdit->text(), &eptr);
   if (*eptr!=0) return "YMax";

   // Seite General
   MaxIter=MaxIterSpin->value();
   CalcM = CalcCombo->currentItem();

   // Seite Convergency
   BailOut = strtod(BailEdit->text(), &eptr);
   if (*eptr!=0) return "BailOut";
   ConvMode=ConvCmb->currentItem();

   // Seite Postcompute
   PotSlope = strtod(PotentialEdit->text(), &eptr);
   if (*eptr!=0) return "PotSlope";
   InsMode = InsideCombo->currentItem();
   OutMode = OutsideCombo->currentItem();
   InsCol = InsideColorSpin->value();
   OutCol = OutsideColorSpin->value();
   ColMode = ColorCombo->currentItem();
   LFirstCol = LogFirstColorSpin->value();
   LogShift = strtod(LogShiftEdit->text(), &eptr);
   if (*eptr!=0) return "LogShift";
   AutoLogColor = AutoLogCheck->isChecked();
   OrbColMode = OrbitColorModeCombo->currentItem();

   // Seite Parameters (float)
   for (Lauf=0; Lauf<16; Lauf++) {
      p[Lauf] = strtod(Par[Lauf]->text(), &eptr);
      if (*eptr!=0){
         // fprintf(stdout,"error %d  >%s<\n",Lauf,Par[Lauf]->text());
         return "Float-params";
      }
   }
   
   Fractal->li = li;
   Fractal->re = re;
   Fractal->un = un;
   Fractal->ob = ob;
   Fractal->MaxIter = MaxIter;
   Fractal->ConvMode = ConvMode;
   Fractal->BailOut = BailOut;
   for (Lauf=0; Lauf<16; Lauf++) Fractal->p[Lauf] = p[Lauf];
   Fractal->InsideMethod = InsMode;
   Fractal->OutsideMethod = OutMode;
   Fractal->InsideColor = InsCol;
   Fractal->OutsideColor = OutCol;
   Fractal->PotentialSlope = PotSlope;
   Client->CalcMethod = CalcM;
   Client->Fractal->ColorMode = ColMode;
   Client->Fractal->LogFirstColor = LFirstCol;
   Client->Fractal->LogShift = LogShift;
   Client->Fractal->AutoLogColor = AutoLogColor;
   Client->OrbitDisplayMode = OrbColMode;

debug("InsideMode=%d\nOutsidemode=%d",InsMode,OutMode);
   return NULL;
}

void FracParamsDlg::PPBtnClick() {

   MaxIterSpin->setValue(MaxIterSpin->value()+25);
}

void FracParamsDlg::MMBtnClick() {

   if (MaxIterSpin->value()>25)
      MaxIterSpin->setValue(MaxIterSpin->value()-25);
}
