#include <stdio.h>
#include <klocale.h>
#include "dlgzoomsettings.h"
//#include "dlgzoomsettings.moc"

ZoomSettingsDlg::ZoomSettingsDlg(DrawWidget* iClient, QWidget* parent, const char* name):
     QTabDialog (parent, name, WStyle_DialogBorder)
{
char Strg[32];

   Client = iClient;
   setFixedSize(400+20,350+30);

   QWidget* ZoomPage = new QWidget(this, i18n("Zoom"));
   
   QGroupBox* ZoomGrp = new QGroupBox(i18n("Zoomfactor"), ZoomPage, "ZoomGrp");
   ZoomGrp->setGeometry(10,10,380,110);
   ZoomEdit = new QLineEdit(ZoomGrp, "ZoomEdit");
   ZoomEdit->setGeometry(25,25,100,25);
   muprintf(Strg,"%0.8f", Client->ZoomFactor);
   ZoomEdit->setText(Strg);
   //ZoomSlider = new KSlider(10,300,5,50,KSlider::Horizontal,ZoomGrp,"ZoomSlider");
   ZoomSlider = new QSlider(QSlider::Horizontal,ZoomGrp,"ZoomSlider");
   ZoomSlider->setRange(10,300);
   ZoomSlider->setSteps(5,20);
   ZoomSlider->setGeometry(20,60,340,20);
   ZoomSlider->setValue((int)(Client->ZoomFactor*10));
   connect(ZoomSlider, SIGNAL(valueChanged(int)), this, SLOT(ZMValChange(int)) );
   QLabel* ZMStartLab = new QLabel("1",ZoomGrp,"ZMStartLab");
   ZMStartLab->setGeometry(22,80,20,20);
   QLabel* ZMEndeLab = new QLabel("30",ZoomGrp,"ZMEndeLab");
   ZMEndeLab->setGeometry(347,80,20,20);

   QGroupBox* AnimGrp = new QGroupBox(i18n("Animationszoomfactor"), ZoomPage, "AnimGrp");
   AnimGrp->setGeometry(10,135,380,160);
   AnimEdit = new QLineEdit(AnimGrp, "AnimEdit");
   AnimEdit->setGeometry(25,25,100,25);
   muprintf(Strg,"%0.8f", Client->ZoomFactorAnimation);
   AnimEdit->setText(Strg);
   AnimSlider = new QSlider(0,200,5,50,QSlider::Horizontal,AnimGrp,"AnimSlider");
   AnimSlider->setSteps(5,20);
   AnimSlider->setGeometry(20,60,340,20);
   AnimSlider->setValue( (int)((Client->ZoomFactorAnimation-1.0)*1000) );
   connect(AnimSlider, SIGNAL(valueChanged(int)), this, SLOT(ZMAnimValChange(int)) );
   QLabel* ZMAStartLab = new QLabel("1",AnimGrp,"ZMAStartLab");
   ZMAStartLab->setGeometry(22,80,20,20);
   QLabel* ZMAEndeLab = new QLabel("1.2",AnimGrp,"ZMAEndeLab");
   ZMAEndeLab->setGeometry(347,80,20,20);
   QLabel* ZMABilderLab = new QLabel(i18n("# Pictures"),AnimGrp,"ZMABilderLab");
   ZMABilderLab->setGeometry(180,25,50,20);
   PicSpin = new QSpinBox(AnimGrp, "PicSpin");
   PicSpin->setGeometry(250,25,50,25);
   PicSpin->setRange(1,30);
   PicSpin->setValue(Client->ZoomAnimationPics);

   QLabel* IterAdjLab = new QLabel(i18n("Maxiter adjust per 10 Pics"), AnimGrp, "IterAdjLab");
   IterAdjLab->setGeometry(20,110,220,20);
   IterSpin=new QSpinBox(AnimGrp, "IterSpin");
   IterSpin->setGeometry(250,110,50,25);
   IterSpin->setRange(0,30);
   IterSpin->setValue(Client->IterIncrement);
   
   QWidget* HistoryPage = new QWidget(this, i18n("History"));
   QLabel* ZoomHistLab = new QLabel("Zoom History max. Factor", HistoryPage, "ZoomHistLab");
   ZoomHistLab->setGeometry(10,20,150,20);
   ZoomHistEdit = new QLineEdit(HistoryPage, "ZoomHistEdit");
   ZoomHistEdit->setGeometry(170,20,100,25);
   muprintf(Strg, "%0.2f", Client->ZoomHistFactor);
   ZoomHistEdit->setText(Strg);
   
   addTab(ZoomPage, i18n("ZOOM"));
   addTab(HistoryPage, i18n("History"));
   
   setDefaultButton(i18n("Defaults"));
   setCancelButton(i18n("Cancel"));
   setOkButton(i18n("OK"));
   connect(this, SIGNAL(defaultButtonPressed()), this, SLOT(SetDefaults()) );
   
   //QPushButton* OkBtn = new QPushButton(i18n("OK"), this, "OkBtn");
   //OkBtn->setGeometry(110,310,80,30);
   //connect(OkBtn, SIGNAL(clicked()), this, SLOT(accept()) );

   //QPushButton* DefaultsBtn = new QPushButton(i18n("Defaults"), this, "DefaultsBtn");
   //DefaultsBtn->setGeometry(210,310,80,30);
   //connect(DefaultsBtn, SIGNAL(clicked()), this, SLOT(SetDefaults()) );

   //QPushButton* CancelBtn = new QPushButton(i18n("Cancel"), this, "CancelBtn");
   //CancelBtn->setGeometry(310,310,80,30);
   //connect(CancelBtn, SIGNAL(clicked()), this, SLOT(reject()) );
}

void ZoomSettingsDlg::SetDefaults()
{
   ZoomEdit->setText("5");
   ZoomSlider->setValue(50);
   AnimEdit->setText("1.03");
   AnimSlider->setValue(30);
   IterSpin->setValue(0);
   ZoomHistEdit->setText("100.0");
}

void ZoomSettingsDlg::ZMValChange(int Val)
{
char Strg[32];
// fprintf(stdout,"ZMValChange, Val=%d\n",Val);
   muprintf(Strg,"%0.8f",0.1*Val);
   ZoomEdit->setText(Strg);
}

void ZoomSettingsDlg::ZMAnimValChange(int Val)
{
char Strg[32];
// fprintf(stdout,"ZMValChange, Val=%d\n",Val);
   muprintf(Strg,"%0.8f",0.001*Val+1.0);
   AnimEdit->setText(Strg);
}

int ZoomSettingsDlg::SetValues()
// Genderte Werte speichern
{
double ZM,ZMA,ZH;
char* eptr =NULL;

   ZM = strtod(ZoomEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;

   ZMA= strtod(AnimEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;

   ZH= strtod(ZoomHistEdit->text(), &eptr);
   if (*eptr!=0) return FALSE;

   Client->ZoomFactor = ZM;
   Client->ZoomFactorAnimation = ZMA;
   Client->ZoomAnimationPics = PicSpin->value();
   Client->IterIncrement = IterSpin->value();
   Client->ZoomHistFactor = ZH;
   return TRUE;
}
